version: "3.7"

services:
  app_proxy:
    environment:
      APP_HOST: $APP_LIGHTNING_IP
      APP_PORT: 3006

  app:
    image: getumbrel/umbrel-lightning:v1.1.2@sha256:3ab819f6335abebb160d2c7b4bd979ad706e25208d219beb9f82d4c1dadd3eff
    restart: on-failure
    volumes:
      - "${APP_LIGHTNING_NODE_DATA_DIR}:/data/.lnd"
      - "${APP_DATA_DIR}/data/lightning:/data"
      - "${UMBREL_ROOT}/statuses:/statuses"
    environment:
      PORT: "3006"
      TOR_PROXY_IP: "${APP_TOR_MAIN_IP}"
      TOR_PROXY_PORT: "9050"
      BITCOIN_HOST: "${APP_BITCOIN_NODE_IP}"
      RPC_PORT: "${APP_BITCOIN_RPC_PORT}"
      RPC_USER: "${APP_BITCOIN_RPC_USER}"
      RPC_PASSWORD: "${APP_BITCOIN_RPC_PASS}"
      LND_NETWORK: "${APP_BITCOIN_NETWORK}"
      LND_HOST: "${APP_LIGHTNING_NODE_IP}"
      LND_REST_HIDDEN_SERVICE: "${APP_LIGHTNING_REST_HIDDEN_SERVICE}"
      LND_GRPC_HIDDEN_SERVICE: "${APP_LIGHTNING_GRPC_HIDDEN_SERVICE}"
      TLS_FILE: "/data/.lnd/tls.cert"
      MACAROON_DIR: "/data/.lnd/data/chain/bitcoin/${APP_BITCOIN_NETWORK}/"
      CHANNEL_BACKUP_FILE: "/data/.lnd/data/chain/bitcoin/${APP_BITCOIN_NETWORK}/channel.backup"
      BACKUP_STATUS_FILE: "/statuses/backup-status.json"
      JSON_STORE_FILE: "/data/state.json"
      JSON_SETTINGS_FILE: "/data/settings.json"
      UMBREL_LND_CONF_FILEPATH: "/data/.lnd/umbrel-lnd.conf"
      LND_CONF_FILEPATH: "/data/.lnd/lnd.conf"
      DEVICE_DOMAIN_NAME: "${DEVICE_DOMAIN_NAME}"
      EXPLORER_PORT: "${APP_MEMPOOL_PORT}"
      EXPLORER_HIDDEN_SERVICE: "${APP_MEMPOOL_HIDDEN_SERVICE}"
    networks:
      default:
        ipv4_address: $APP_LIGHTNING_IP

  lnd:
    image: harbor.nirvati.org/nirvati/port-proxy:latest
    user: 1000:1000
    restart: unless-stopped
    environment:
      PROXY_PORTS: "$APP_LIGHTNING_NODE_PORT:{{APP_LND_SERVICE_IP}}:$APP_LIGHTNING_NODE_PORT/tcp,$APP_LIGHTNING_NODE_REST_PORT:{{APP_LND_SERVICE_IP}}:$APP_LIGHTNING_NODE_REST_PORT/tcp,$APP_LIGHTNING_NODE_GRPC_PORT:{{APP_LND_SERVICE_IP}}:$APP_LIGHTNING_NODE_GRPC_PORT/tcp"
    networks:
      default:
        ipv4_address: $APP_LIGHTNING_NODE_IP

  # TODO: Replace with Nirvati's Tor proxy
  tor:
    image: getumbrel/tor:0.4.7.8@sha256:2ace83f22501f58857fa9b403009f595137fa2e7986c4fda79d82a8119072b6a
    user: "1000:1000"
    restart: on-failure
    volumes:
      - ${APP_DATA_DIR}/torrc:/etc/tor/torrc:ro
      - ${TOR_DATA_DIR}:/data
    environment:
      HOME: "/tmp"
